From c4b180de354f27febeb1342d6c5ecc1782ea5a49 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 08 2015 03:27:57 +0000
Subject: [PATCH 100/1001] Fill out all the invalidate functions we currently have.


---

diff --git a/hubs/consumer.py b/hubs/consumer.py
index da79a59..1515966 100644
--- a/hubs/consumer.py
+++ b/hubs/consumer.py
@@ -43,18 +43,24 @@ class CacheInvalidatorExtraordinaire(fedmsg.consumers.FedmsgConsumer):
     def rebuild_hubs_hint_caches(self, session):
         self.checks_by_topic = collections.defaultdict(list)
         self.checks_by_category = collections.defaultdict(list)
+        self.checks_by_username = collections.defaultdict(list)
 
         widgets = session.query(hubs.models.Widget).all()
         log.info("Comparing message against %i widgets" % len(widgets))
         for widget in widgets:
             check = widget.module.should_invalidate
+
             if not hasattr(check, 'hints'):
                 raise AttributeError("%r must declare hints" % widget.module)
+
             for topic in check.hints['topics']:
                 self.checks_by_topic[topic].append((check, widget,))
+
             for category in check.hints['categories']:
                 self.checks_by_category[category].append((check, widget,))
 
+            for username in check.hints['usernames_function']:
+                self.checks_by_username[username].append((check, widget,))
 
     @property
     def cache_initialized(self):
diff --git a/hubs/hinting.py b/hubs/hinting.py
index 64a58ed..47e7d14 100644
--- a/hubs/hinting.py
+++ b/hubs/hinting.py
@@ -7,9 +7,10 @@ import logging
 log = logging.getLogger('hubs.hinting')
 
 
-def hint(topics=None, categories=None):
+def hint(topics=None, categories=None, usernames=None):
     topics = topics or []
     categories = categories or []
+    usernames = usernames or lambda x: []
 
     @decorator.decorator
     def wrapper(fn, *args, **kwargs):
@@ -17,7 +18,11 @@ def hint(topics=None, categories=None):
 
     def wrapper_wrapper(fn):
         wrapped = wrapper(fn)
-        wrapped.hints = dict(topics=topics, categories=categories)
+        wrapped.hints = dict(
+            topics=topics,
+            categories=categories,
+            username_function=usernames,
+        )
         return wrapped
 
     return wrapper_wrapper
diff --git a/hubs/widgets/about.py b/hubs/widgets/about.py
index a6f8eae..55693c9 100644
--- a/hubs/widgets/about.py
+++ b/hubs/widgets/about.py
@@ -19,5 +19,10 @@ def data(session, widget, text):
     return dict(text=text)
 
 
+@hint(topics=[_('hubs.widget.update')])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError
+    if not message['topic'].endswith('hubs.widget.update'):
+        return False
+    if message['msg']['widget']['id'] != widget.id:
+        return False
+    return True
diff --git a/hubs/widgets/avatar.py b/hubs/widgets/avatar.py
index 20c12ab..bcda21d 100644
--- a/hubs/widgets/avatar.py
+++ b/hubs/widgets/avatar.py
@@ -23,5 +23,10 @@ def data(session, widget, username):
     return dict(username=username, avatar=avatar)
 
 
+@hint(topics=[_('hubs.widget.update')])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError
+    if not message['topic'].endswith('hubs.widget.update'):
+        return False
+    if message['msg']['widget']['id'] != widget.id:
+        return False
+    return True
diff --git a/hubs/widgets/badges.py b/hubs/widgets/badges.py
index 14ed116..4e6234d 100644
--- a/hubs/widgets/badges.py
+++ b/hubs/widgets/badges.py
@@ -1,5 +1,6 @@
 import requests
 
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.base import argument
 
 import jinja2
@@ -31,5 +32,15 @@ def data(session, widget, username):
     return response.json()
 
 
+@hint(topics=[_('hubs.widget.update'), _('fedbadges.badge.award')])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError
+    if message['topic'].endswith('hubs.widget.update'):
+        if message['msg']['widget']['id'] != widget.id:
+            return True
+
+    if message['topic'].endswith('fedbadges.badge.award'):
+        username = widget.config['username']
+        if message['msg']['user']['username'] == username:
+            return True
+
+    return False
diff --git a/hubs/widgets/fedmsgs.py b/hubs/widgets/fedmsgs.py
index 6f7dcf1..62e4d2c 100644
--- a/hubs/widgets/fedmsgs.py
+++ b/hubs/widgets/fedmsgs.py
@@ -1,10 +1,13 @@
+from hubs.hinting import hint
 from hubs.widgets.base import argument
 
 import jinja2
 
-
 import hubs.validators as validators
 
+import fedmsg.config
+config = fedmsg.config.load_config()
+
 
 template = jinja2.Template("""
 <div class="flex-container">
@@ -28,5 +31,8 @@ def data(session, widget, username):
     return dict(url=url)
 
 
+@hint(usernames=lambda widget: [widget.config['username']])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError
+    usernames = fedmsg.meta.msg2usernames(message, **config)
+    username = widget.config['username']
+    return username in usernames
diff --git a/hubs/widgets/fedmsgstats.py b/hubs/widgets/fedmsgstats.py
index bd2323b..0c22872 100644
--- a/hubs/widgets/fedmsgstats.py
+++ b/hubs/widgets/fedmsgstats.py
@@ -27,5 +27,8 @@ def data(session, widget, username):
     )
 
 
+@hint(usernames=lambda widget: [widget.config['username']])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError
+    usernames = fedmsg.meta.msg2usernames(message, **config)
+    username = widget.config['username']
+    return username in usernames
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
index 8f40a86..9e40b73 100644
--- a/hubs/widgets/workflow/pendingacls.py
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -1,5 +1,6 @@
 import requests
 
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.base import argument
 from hubs.utils import username2avatar
 
@@ -57,5 +58,13 @@ def data(session, widget, username):
     return data
 
 
+@hint(topics=[_('pkgdb.acl.update')])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError
+    # Search the message to see if I am in the ACLs list of the request.
+    username = widget.config['username']
+
+    for acl in message['msg']['package_listing']['acls']:
+        if acl['fas_name'] == username and acl['status'] == 'Approved':
+            return True
+
+    return False
diff --git a/hubs/widgets/workflow/updates2stable.py b/hubs/widgets/workflow/updates2stable.py
index 905b5fd..da410db 100644
--- a/hubs/widgets/workflow/updates2stable.py
+++ b/hubs/widgets/workflow/updates2stable.py
@@ -1,5 +1,6 @@
 import requests
 
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.base import argument
 
 import jinja2
@@ -35,6 +36,9 @@ from hubs.widgets.chrome import panel
 chrome = panel('Updates Ready for Stable', key='updates')
 
 
+giveaway = 'can be pushed to stable now'
+
+
 @argument(name="username",
           default=None,
           validator=validators.username,
@@ -52,7 +56,6 @@ def data(session, widget, username):
 
     # Limit it this to only the updates that haven't already requested stable
     # but which can actually be pushed to stable now.
-    giveaway = 'can be pushed to stable now'
     data['updates'] = [
         update for update in data['updates']
         if update['request'] is None and
@@ -69,5 +72,11 @@ def data(session, widget, username):
     return data
 
 
+@hint(topics=[_('bodhi.update.comment')])
 def should_invalidate(message, session, widget):
-    raise NotImplementedError
+    if giveaway in message['msg']['comment']['text']:
+        username = widget.config['username']
+        if username == message['msg']['comment']['update_submitter']:
+            return True
+
+    return False

